package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ListNetworkSegmentRangesRangeLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListNetworkSegmentRangesRangeLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListNetworkSegmentRangesRangeLogic {
	return &ListNetworkSegmentRangesRangeLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListNetworkSegmentRangesRangeLogic) ListNetworkSegmentRangesRange(req *types.ListNetworkSegmentRangesReq) (resp *types.ListNetworkSegmentRangesResp, err error) {
	// todo: add your logic here and delete this line
	ListNetworkSegmentRangesReq := &openstack.ListNetworkSegmentRangesReq{}
	err = copier.CopyWithOption(ListNetworkSegmentRangesReq, req, copier.Option{Converters: utils.Converters})
	ListNetworkSegmentRangesResp, err := l.svcCtx.OpenstackRpc.ListNetworkSegmentRanges(l.ctx, ListNetworkSegmentRangesReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ListNetworkSegmentRangesResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ListNetworkSegmentRangesResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
